//
//  MGLinedTextView.m *** based on KBlinedTextView from Keath Blound
//  littleNotes
//
//  Created by Michael on 23.05.10.
//  Copyright 2010 MOApp. All rights reserved.
//

#import "MGLinedTextView.h"

@implementation MGLinedTextView


#pragma mark -
#pragma mark Init/Dealloc


-(IBAction)applyFont:(id)sender;
{
	[self initLinedTextView];
}


- (void)initLinedTextView
{
	
	int size;
	int tag1 = [[NSUserDefaults standardUserDefaults] integerForKey: @"notesSize"];			
	switch (tag1)
	{
		case 0:
			size = 11;
			break;			
		case 1:
			size = 12;
			break;
			
		case 2:
			size = 13;
			break;
		case 3:
			size = 14;
			break;
		case 4:
			size = 15;
			break;
		case 5:
			size = 16;
			break;
		case 6:
			size = 17;
			break;
		case 7:
			size = 18;
			break;
		case 8:
			size = 19;
			break;
			
		default:
			size = 13;
			break;				
	}	
	
	
	NSString *selectedFont;		
	int tag001 = [[NSUserDefaults standardUserDefaults] integerForKey: @"notesFont"];
	switch (tag001)
	{
			selectedFont = @"Typewriter";
			break;
			
		case 1:
			selectedFont = @"Arial";
			break;			
		case 2:
			selectedFont = @"Courier";
			break;
		case 3:
			selectedFont = @"Georgia";
			break;
		case 4:
			selectedFont = @"Helvetica";
			break;
		case 5:
			selectedFont = @"Times";
			break;
		case 6:
			selectedFont = @"Verdana";
			break;	
		default:
			selectedFont = @"Georgia";
			break;			
	}
	
	
	
	if ( [[NSUserDefaults standardUserDefaults] boolForKey: @"noLines"] == 0)		
	{	
		[self setLineColor:[NSColor colorWithDeviceCyan:(0.39f) magenta:(0.22f) yellow:(0.06f) black:(0.00f) alpha:(0.1f)]];
	}
	else
	{
		[self setLineColor:[NSColor colorWithDeviceCyan:(0.39f) magenta:(0.22f) yellow:(0.06f) black:(0.00f) alpha:(0.0f)]];
	}
	[self setImage:nil];
	[self setDrawsLinesAndImage:NO];
	
	NSColor *color = [NSColor blackColor];
	NSFont *font;
	font = [NSFont fontWithName:@"Monaco" size:11];
	
	NSMutableParagraphStyle *paragraph = [[NSMutableParagraphStyle alloc] init];
	[paragraph setLineSpacing:2];	
	
	[self setTypingAttributes:[NSDictionary dictionaryWithObjectsAndKeys:font, NSFontAttributeName, color, NSForegroundColorAttributeName,  paragraph,    NSParagraphStyleAttributeName, nil]];
	
	NSSize sizeMargin;
	sizeMargin.width = 20;
	sizeMargin.height = 17;
	[self setTextContainerInset:sizeMargin];
	[self setBackgroundColor:[NSColor colorWithDeviceCyan:(1.0f) magenta:(1.0f) yellow:(1.0f) black:(1.00f) alpha:(0.0f)]];
}

- (id)initWithFrame:(NSRect)frameRect textContainer:(NSTextContainer *)textContainer
{
	if (self = [super initWithFrame:frameRect textContainer:textContainer])
	{
		[self initLinedTextView];
	}
	return self;
}

- (id)initWithCoder:(NSCoder *)coder
{
	if (self = [super initWithCoder:coder])
	{
		[self initLinedTextView];
	}
	return self;
}

- (void)dealloc
{
	[lineColor release];
	[image release];
	[super dealloc];
}


#pragma mark -
#pragma mark Accessor 

- (void)setLineColor:(NSColor *)color
{
	[color retain];
	[lineColor release];
	lineColor = color;
	[self setNeedsDisplayInRect:[self visibleRect]];
}

- (NSColor *)lineColor
{
	return lineColor;
}

- (void)setImage:(NSImage *)newImage
{
	[newImage retain];
	[image release];
	image = newImage;
	[self setNeedsDisplayInRect:[self visibleRect]];
}

- (NSImage *)image
{
	return image;
}

- (void)setDrawsLinesAndImage:(BOOL)flag
{
	drawsLinesAndImage = flag;
	[self setNeedsDisplayInRect:[self visibleRect]];
}

- (BOOL)drawsLinesAndImage
{
	return drawsLinesAndImage;
}



#pragma mark -
#pragma mark Drawing Methods

- (NSRange)glyphRangeForRect:(NSRect)aRect
{
	NSRange glyphRange;
    NSLayoutManager *layoutManager = [self layoutManager];
    NSTextContainer *textContainer = [self textContainer];
    NSPoint containerOrigin = [self textContainerOrigin];
	
	aRect = NSOffsetRect(aRect, -containerOrigin.x, -containerOrigin.y);	
    glyphRange = [layoutManager glyphRangeForBoundingRect:aRect inTextContainer:textContainer];
	
	return glyphRange;
}

- (void)drawViewBackgroundInRect:(NSRect)rect
{
	[super drawViewBackgroundInRect:rect];
	
	if (image)
	{
		BOOL imageFlippedState = [image isFlipped];
		[image setFlipped:YES];
		NSRect imgRect = NSMakeRect(0,0,[image size].width,[image size].height);
		NSRect drawRect = rect;
		drawRect.size.width = drawRect.size.height * (imgRect.size.width/imgRect.size.height);
		drawRect.origin.x += (rect.size.width - drawRect.size.width)/2.0;
		if (drawRect.size.width > rect.size.width)
		{
			drawRect = rect;
			drawRect.size.height = drawRect.size.width * (imgRect.size.height/imgRect.size.width);
			drawRect.origin.y += (rect.size.height - drawRect.size.height)/2.0;
		}
		
		[image drawInRect:drawRect fromRect:imgRect	operation:NSCompositeSourceOver fraction:0.25];		
		[image setFlipped:imageFlippedState];

		if (![self drawsLinesAndImage])
			return;
	}
	

	float bezierDefaultLineWidth = [NSBezierPath defaultLineWidth];
	[NSBezierPath setDefaultLineWidth:1.0];
	NSLayoutManager *layoutManager = [self layoutManager];
	NSPoint p1, p2;
    NSRange lineRange;
	float defaultLineHeight;
	if ([self typingAttributes])
	{
		defaultLineHeight = [layoutManager defaultLineHeightForFont:
							 [[self typingAttributes] objectForKey:NSFontAttributeName]];
	}
	else
		defaultLineHeight = 14.0;
	
	NSRect lineRect = NSMakeRect(0,rect.origin.y-defaultLineHeight,0,defaultLineHeight);
	NSRange glyphRange = [self glyphRangeForRect:rect];
	unsigned i = glyphRange.location;
	
	[lineColor set];

	while (i < NSMaxRange(glyphRange))
	{
        lineRect = [layoutManager lineFragmentRectForGlyphAtIndex:i effectiveRange:&lineRange];		
		p1 = NSMakePoint(rect.origin.x, (int)NSMaxY(lineRect)+0.5);
		p2 = NSMakePoint(NSMaxX(rect), (int)NSMaxY(lineRect)+0.5);
		[NSBezierPath strokeLineFromPoint:p1 toPoint:p2];		
        i = NSMaxRange(lineRange);
    }

	while (NSMaxY(lineRect) < NSMaxY(rect))
	{
		lineRect.origin.y += lineRect.size.height;
		p1 = NSMakePoint(rect.origin.x, (int)NSMaxY(lineRect)+0.5);
		p2 = NSMakePoint(NSMaxX(rect), (int)NSMaxY(lineRect)+0.5);
		[NSBezierPath strokeLineFromPoint:p1 toPoint:p2];
	}
	
	[NSBezierPath setDefaultLineWidth:bezierDefaultLineWidth];
}

- (void)setNeedsDisplayInRect:(NSRect)aRect avoidAdditionalLayout:(BOOL)flag
{
	[super setNeedsDisplayInRect:[self visibleRect] avoidAdditionalLayout:flag];
}

@end
